## hime 0.9.9

=== Makefile ===
include config.mak

VERSION_FILE = VERSION.hime

DIR    = src data filter scripts icons man menu

ifeq ($(ECHO),)
ECHO  := $(shell whereis -b echo|sed 's/^echo: *\([^ ]\+\).*/\1/')
ifeq ($(ECHO),)
ECHO   = echo
endif
endif

ifeq ($(USE_I18N),Y)
DIR   += po
endif


all:
	@for d in $(DIR); do $(ECHO) -e "\x1b[1;33m** processing $$d\x1b[0m"; \
	   $(MAKE) -C $$d; \
	done

install:
	@for d in $(DIR); do $(ECHO) -e "\x1b[1;32m** installing $$d\x1b[0m"; \
	   $(MAKE) -C $$d install; \
	done
	@if [ $(prefix) = /usr/local ]; then \
	   install -m 644 icons/hime.png /usr/share/pixmaps; \
	   install -d $(DOC_DIR); \
	   install -m 644 ChangeLog $(DOC_DIR); \
	else \
	   install -d $(DOC_DIR_i); \
	   install -m 644 ChangeLog $(DOC_DIR_i); \
	fi

clean:
	@touch src/.depend
	@for d in $(DIR); do $(ECHO) -e "\x1b[1;31m** cleanup $$d\x1b[0m"; \
	   $(MAKE) -C $$d clean; \
	done

distclean:
	@$(MAKE) clean
	@rm -f config.mak

config.mak: $(VERSION_FILE) configure
	@$(ECHO) "regenerate $@ ..."
	./configure

=== data/Makefile ===
include ../config.mak

SRC_DIR       = ../src
IM_CLIENT_DIR = $(SRC_DIR)/im-client

.SUFFIXES:	.kbmsrc .kbm .cin .gtab
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I$(SRC_DIR)
export NO_GTK_INIT=
export HIME_NO_RELOAD=

DATA=pho.tab2 tsin32.idx gtab.list \
     cj.gtab ar30.gtab ar30-big.gtab pinyin.gtab jyutping.gtab cj5.gtab \
     et.kbm et26.kbm zo.kbm pinyin.kbm dvorak.kbm mitac.kbm colemak.kbm \
     ibm.kbm tsin32 hsu.kbm pho-huge.tab2 simplex.gtab symbols.gtab russian.gtab \
     greek.gtab cj-punc.gtab latin-letters.gtab tsin-1.src pin-juyin.xlt \
     t2s.dat s2t.dat cj543.gtab s-tsin32 s-tsin32.idx s-pho.tab2 s-pho-huge.tab2 \
     pinyin-no-tone.kbm simplex-punc.gtab hangul.gtab

DATAKEEP = symbol-table phrase.table phrase-ctrl.table

PHO_A2D    = $(SRC_DIR)/hime-phoa2d
TS_A2D     = $(SRC_DIR)/hime-tsa2d32
CIN2GTAB   = $(SRC_DIR)/cin2gtab
KBMCV      = $(SRC_DIR)/kbmcv
PIN_JUYIN  = $(SRC_DIR)/pin-juyin

ifeq ($(USE_TSIN),Y)
REMOVE_TSIN = keep_tsin
endif

ifeq ($(USE_TSIN),N)
REMOVE_TSIN = remove_tsin
endif

ifeq ($(INSTALL_DFSG_INCOMPATIBLE),Y)
DATA += dayi3.gtab
endif

all:	$(DATA)

$(PHO_A2D):
	$(MAKE) -C $(SRC_DIR) hime-phoa2d

$(TS_A2D):
	$(MAKE) -C $(SRC_DIR) hime-tsa2d32

$(CIN2GTAB):
	$(MAKE) -C $(SRC_DIR) cin2gtab

$(KBMCV):
	$(MAKE) -C $(SRC_DIR) kbmcv

$(PIN_JUYIN):
	$(MAKE) -C $(SRC_DIR) pin-juyin

tsin32:	tsin.src  $(TS_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(TS_A2D) $<
tsin32.idx:	tsin32


s-tsin32:	s-tsin.src  $(TS_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(TS_A2D) $< $@
s-tsin32.idx:	s-tsin32


pho.tab2:	 pho.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

s-pho.tab2:	 s-pho.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

pho-huge.tab2:	 pho-huge.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

s-pho-huge.tab2:	 s-pho-huge.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

t2s.dat:	t2s-file t2s-file.table
	./t2s-file
s2t.dat:	t2s-file

pin-juyin.xlt: $(PIN_JUYIN) pin-juyin.src
	$(PIN_JUYIN)

extr1:	extr1.c
	@echo "building $@ ..."
	@$(CC) $(CFLAGS) $< $(SRC_DIR)/util.o $(SRC_DIR)/locale.o -o $@ $(LDFLAGS)

t2s-file:	t2s-file.c
	@echo "building $@ ..."
	@$(CC) $(CFLAGS) $< $(SRC_DIR)/util.o $(SRC_DIR)/locale.o -o $@ $(LDFLAGS)

tsin-1.src:	extr1
	./extr1 > $@

.cin.gtab: $(CIN2GTAB)
	$(CIN2GTAB) $<

.kbmsrc.kbm: $(KBMCV)
	$(KBMCV) $<

keep_tsin: gtab.list.in
	cp gtab.list.in gtab.list

remove_tsin: gtab.list.in
	grep -v TSIN gtab.list.in > gtab.list

gtab.list: $(REMOVE_TSIN)
	touch gtab.list

install:
	install -d $(HIME_TABLE_DIR_i)
	install -m 644 $(DATA) $(DATAKEEP) $(HIME_TABLE_DIR_i)
#	cd $(HIME_TABLE_DIR_i); bzip2 -f *.gtab

clean:
	@echo "clean up"
	@rm -f *~ tags core.* $(DATA) *.gtab extr1 t2s-file tsin-1.src tsin-gtabidx* tsin-ch-idx gtab.list

=== filter/Makefile ===
include ../config.mak

all:

install:
	install -d $(DESTDIR)/$(filterdir)
	install -m 755 [a-z]* $(DESTDIR)/$(filterdir)

clean:
	@echo "clean up"
	@rm -f *~

=== icons/Makefile ===
include ../config.mak

DIR    = black dark gray pink

ifeq ($(ECHO),)
ECHO  := $(shell whereis -b echo|sed 's/^echo: *\([^ ]\+\).*/\1/')
ifeq ($(ECHO),)
ECHO   = echo
endif
endif

all:

install:
	install -d $(datadir)/pixmaps
	install -m 644 hime.png $(datadir)/pixmaps
	install -d $(HIME_ICON_DIR_i)
	install -m 644 30x30/*.png $(HIME_ICON_DIR_i)
	@for d in $(DIR); do \
	   set -x ; \
	   $(ECHO) -e "\x1b[1;32m** installing icons/$$d\x1b[0m"; \
	   install -d $(HIME_ICON_DIR_i)/$$d ; \
	   install -m 644 $$d/*.png $(HIME_ICON_DIR_i)/$$d ; \
	done

clean:

=== po/Makefile ===
include ../config.mak

.SUFFIXES: .po .gmo

.po.gmo:
	file=`echo $* | sed 's,.*/,,'`.gmo \
		&& rm -f $$file && msgfmt -o $$file $<

all: en_US.gmo zh_CN.gmo

hime.pot:
	xgettext --from-code=UTF-8 --keyword=_ --keyword=N_ -o $@ ../*/*.c ../src/*/*.c*

update-po: hime.pot
	msgmerge en_US.po hime.pot > en_US.new.po
	msgmerge zh_CN.po hime.pot > zh_CN.new.po
	mv en_US.new.po en_US.po
	mv zh_CN.new.po zh_CN.po

install:
	install -d $(datadir)/locale/en_US/LC_MESSAGES
	install -d $(datadir)/locale/zh_CN/LC_MESSAGES
	install -m 644 en_US.gmo $(datadir)/locale/en_US/LC_MESSAGES/hime.mo
	install -m 644 zh_CN.gmo $(datadir)/locale/zh_CN/LC_MESSAGES/hime.mo

clean:
	rm -f ./hime.pot *.gmo *.new.po

=== scripts/Makefile ===
include ../config.mak

SCRIPTS=hime-user-setup utf8-edit gtab.append_prepare tsin-gtab-import tsin-gtab-edit
BIN_SCRIPTS=hime-env

all:	$(SCRIPTS)

install:
	install -d $(HIME_SCRIPT_DIR_i)
	install -m 755 $(SCRIPTS) $(HIME_SCRIPT_DIR_i)
	install -d $(bindir)
	install -m 755 $(BIN_SCRIPTS) $(bindir)

clean:
	@echo "clean up"
	@rm -f *~ tags core.*

=== src/Makefile ===

include ../config.mak

CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I./IMdkit/include -I./im-client \
        -DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
        -DHIME_OGG_DIR=\"$(HIME_OGG_DIR)\" \
        -DDOC_DIR=\"$(DOC_DIR)\" \
        -DHIME_ICON_DIR=\"$(HIME_ICON_DIR)\" \
        -DHIME_SCRIPT_DIR=\"$(HIME_SCRIPT_DIR)\" -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" \
        -DSYS_ICON_DIR=\"$(SYS_ICON_DIR)\" -DFREEBSD=$(FREEBSD) -DMAC_OS=$(MAC_OS) \
        -DG_DISABLE_SINGLE_INCLUDES -DG_DISABLE_DEPRECATED \
        -DGDK_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
        -DGTK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED -DGSEAL_ENABLE

VERSION_FILE = ../VERSION.hime

OBJ_IMSRV = im-addr.o im-dispatch.o im-srv.o hime-crypt.o

HIME1_OBJ = win-message.pico win-sym.pico win-inmd-switch.pico pinyin.pico \
	win-pho-near.pico win-kbm.pico hime-module.pico pho2pinyin.pico
HIME2_OBJ = t2s-lookup.pico


hime_pho_o  = win-pho.o pho.o pho-util.o pho-sym.o table-update.o pho-dbg.o
hime_gtab_o = gtab.o win-gtab.o gtab-util.o gtab-list.o gtab-buf.o


OBJS      = hime.o eve.o util.o hime-conf.o hime-settings.o locale.o \
	hime-icon.o about.o \
	hime-exec-script.o pho-play.o cache.o gtk_bug_fix.o \
	phrase-save-menu.o \
	$(hime_pho_o) $(hime_gtab_o) \
	hime-common.o phrase.o t2s-lookup.o gtab-use-count.o \
	win-save-phrase.o unix-exec.o pho-kbm-name.o statistic.o tsin-scan.o \
	hime-module.o lang.o \
	hime-module-cb.o gtab-init.o fullchar.o gtab-tsin-fname.o

OBJS_TSLEARN = hime-tslearn.o util.o hime-conf.o pho-util.o tsin-util.o \
	pho-sym.o table-update.o locale.o \
	hime-settings.o hime-common.o hime-icon.o pho-dbg.o \
	pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
	gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_TS_EDIT = hime-ts-edit.o util.o hime-conf.o pho-util.o tsin-util.o \
	pho-sym.o table-update.o locale.o \
	hime-settings.o hime-common.o hime-icon.o pho-dbg.o \
	pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
	gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_JUYIN_LEARN = hime-juyin-learn.o locale.o util.o pho-util.o pho-sym.o \
	pho2pinyin.o hime-settings.o hime-conf.o table-update.o pinyin.o \
	hime-icon.o pho-dbg.o

OBJS_hime-sim2trad = hime-sim2trad.o util.o hime2.so locale.o hime-conf.o hime-icon.o

OBJS_hime-phod2a = hime-phod2a.o pho-util.o hime-conf.o pho-sym.o table-update.o \
	pho-dbg.o locale.o hime-settings.o util.o

OBJS_hime-tsa2d32 = hime-tsa2d32.o util.o pho-sym.o hime-conf.o \
	locale.o pho-lookup.o pinyin.o pho2pinyin.o pho-dbg.o

OBJS_hime-phoa2d = hime-phoa2d.o pho-sym.o hime-conf.o locale.o \
	pho-lookup.o util.o pho-dbg.o

OBJS_kbmcv = kbmcv.o pho-sym.o util.o locale.o

OBJS_hime-tsd2a32 = hime-tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o \
	gtab-dbg.o pho2pinyin.o hime-conf.o pinyin.o

OBJS_cin2gtab     = cin2gtab.o gtab-util.o util.o locale.o
OBJS_gtab2cin     = gtab2cin.o gtab-util.o util.o locale.o
OBJS_gtab_merge   = hime-gtab-merge.o gtab-util.o util.o locale.o
OBJS_hime_setup   = hime-setup.o hime-conf.o util.o hime-settings.o \
	hime-setup-list.o locale.o hime-setup-pho.o about.o \
	lang.o hime-icon.o hime-setup-gtab.o gtab-list.o hime-exec-script.o \
	pho-kbm-name.o hime-module-cb.o

OBJS_hime_gb_toggle  = hime-gb-toggle.o  hime-conf.o util.o
OBJS_hime_message    = hime-message.o    hime-conf.o util.o

OBJS_pin_juyin       = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o

OBJS_tsin2gtab_phrase = hime-tsin2gtab-phrase.o hime-conf.o util.o locale.o \
	pho-dbg.o pho-sym.o gtab-dbg.o lang.o


#WALL=-Wall

ifeq ($(USE_XIM),Y)
IMdkitLIB   = IMdkit/lib/libXimd.a
CFLAGS     += -DUSE_XIM=1
OBJS       += IC.o
endif

ifeq ($(USE_TRAY),Y)
CFLAGS     += -DTRAY_ENABLED=1
OBJS       += tray.o eggtrayicon.o tray-double.o
ifeq ($(USE_UNITY),Y)
CFLAGS     += -DTRAY_UNITY=1
OBJS       += tray-appindicator.o
endif
endif

ifeq ($(USE_I18N),Y)
CFLAGS     += -DHIME_i18n_message=1
endif

ifeq ($(USE_TSIN),Y)
hime_tsin_o = tsin.o tsin-util.o win0.o win1.o tsin-parse.o
CFLAGS     += -DUSE_TSIN=1
OBJS       += $(hime_tsin_o)
endif

# Temporary workaround to turn off Tsin, will be fixed later
ifeq ($(USE_TSIN),N)
OBJS       += tsin.o tsin-util.o win0.o win1.o tsin-parse.o
endif

ifeq ($(MAC_OS),1)
EXTRA_LDFLAGS=-bind_at_load 
endif

ifeq ($(GIT_HAVE),Y)
CFLAGS     += -DGIT_HASH=\"$(GIT_HASH)\" -DGIT_HAVE=1
endif

HIME_SO   = hime1.so hime2.so

PROGS     = hime \
	hime-tsd2a32 hime-tsa2d32 hime-phoa2d hime-phod2a \
	hime-tslearn hime-setup cin2gtab gtab2cin \
	hime-juyin-learn hime-sim2trad hime-gb-toggle hime-message hime-gtab-merge \
	hime-tsin2gtab-phrase hime-ts-edit

PROGS_SYM = hime-trad2sim hime-exit hime-sim hime-trad hime-kbm-toggle

PROGS_CV  = kbmcv pin-juyin

.SUFFIXES:  .c .o .E .pico .cpp

.cpp.o:
	@echo "  $< -> $@"
	@$(CCX) $(CFLAGS) -c $<
.c.o:
	@echo "  $< -> $@"
	@$(CC) $(CFLAGS) -c $<
.c.pico:
	@echo "  $< -> $@"
	@$(CC) $(CFLAGS) -c -fpic -o $@ $<
.cpp.pico:
	@echo "  $< -> $@"
	@$(CCX) $(CFLAGS) -c -fpic -o $@ $<
.c.E:
	@echo "  $< -> $@"
	@$(CC) $(CFLAGS) -E -o $@ $<
.cpp.E:
	@echo "  $< -> $@"
	@$(CCX) $(CFLAGS) -E -o $@ $<


all: hime-version.h $(PROGS) $(PROGS_SYM) $(DATA) $(PROGS_CV)
	if [ $(BUILD_MODULE) = 'Y' ]; then $(MAKE) -C modules; fi
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi

hime1.so: $(HIME1_OBJ)
	@echo "linking $@ ..."
	@$(CCLD) $(SO_FLAGS) -o $@ $^ $(LDFLAGS)

hime2.so: $(HIME2_OBJ)
	@echo "linking $@ ..."
	@$(CCLD) $(SO_FLAGS) -o $@ $^ $(LDFLAGS)

$(IMdkitLIB):
	@echo "building $@ ..."
	$(MAKE) -C IMdkit/lib

im-client/libhime-im-client.so:
	@echo "building $@ ..."
	$(MAKE) -C im-client

hime: $(HIME_SO) $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	@echo "linking $@ ..."
	@$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) $(HIME_SO) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
	@rm -f core.* vgcore.*

hime-tslearn: $(OBJS_TSLEARN) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-ts-edit: $(OBJS_TS_EDIT) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-juyin-learn: $(OBJS_JUYIN_LEARN)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)
	@rm -f core.*

hime-sim2trad: $(OBJS_hime-sim2trad)
	@echo "linking $@ ..."
	@$(CC) $(gcc_ld_run_path) -o $@ $^ $(LDFLAGS)
	@rm -f core.*

hime-trad2sim:  hime-sim2trad
	ln -sf hime-sim2trad $@

hime-setup: $(OBJS_hime_setup) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@rm -f core.*
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-phoa2d: $(OBJS_hime-phoa2d) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-phod2a: $(OBJS_hime-phod2a)
	@echo "linking $@ ..."
	@$(CCLD) -lX11 -o $@ $^ $(LDFLAGS)

hime-tsa2d32:  $(OBJS_hime-tsa2d32) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

#hime-tsd2a:
#	$(CCLD) -o $@ $(LDFLAGS)

hime-tsd2a32: $(OBJS_hime-tsd2a32)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)


cin2gtab: $(OBJS_cin2gtab)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)
	@rm -f data/*.gtab

gtab2cin: $(OBJS_gtab2cin)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

hime-gtab-merge: $(OBJS_gtab_merge)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

kbmcv: $(OBJS_kbmcv)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

hime-gb-toggle: $(OBJS_hime_gb_toggle) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-kbm-toggle: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-exit: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-trad: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-sim: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-message: $(OBJS_hime_message) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

pin-juyin: $(OBJS_pin_juyin)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)

hime-tsin2gtab-phrase: $(OBJS_tsin2gtab_phrase)
	@echo "linking $@ ..."
	@$(CCLD) -o $@ $^ $(LDFLAGS)


hime-version.h: $(VERSION_FILE)
	@echo "building $@ ... current version is '"`cat $<`"'"
	@echo '#define HIME_VERSION "'`cat $<`'"' > $@

install:
	install -d $(bindir)
	install $(PROGS) $(bindir)
	rm -f $(bindir)/hime-trad2sim; ln -sf hime-sim2trad $(bindir)/hime-trad2sim
	rm -f $(bindir)/hime-exit; ln -sf hime-gb-toggle $(bindir)/hime-exit
	rm -f $(bindir)/hime-trad; ln -sf hime-gb-toggle $(bindir)/hime-trad
	rm -f $(bindir)/hime-sim; ln -sf hime-gb-toggle $(bindir)/hime-sim
	rm -f $(bindir)/hime-kbm-toggle; ln -sf hime-gb-toggle $(bindir)/hime-kbm-toggle
	install -d $(himelibdir)
	install $(HIME_SO) $(himelibdir)
	install -d $(includedir)
	install -m 644 im-client/hime-im-client.h im-client/hime-im-client-attr.h $(includedir)
	$(MAKE) -C im-client install
	if [ $(BUILD_MODULE) = 'Y' ]; then $(MAKE) -C modules install; fi
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im install; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im install; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi

clean:
	@echo "clean up"
	$(MAKE) -C IMdkit clean
	$(MAKE) -C im-client clean
	$(MAKE) -C modules clean
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im clean; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im clean; fi
	$(MAKE) -C qt-im clean
	$(MAKE) -C qt4-im clean
	@rm -f *.o *.E *.db *.pico *.so tags $(PROGS) $(PROGS_CV) \
		$(DATA) .depend $(PROGS_SYM) hime.log hime-fedora.spec
	@find . '(' -name '.ted*' -o -name '*~' -o -name 'core.*' -o -name 'vgcore.*' ')' -exec rm {} \;

.depend:
	@echo "building $@ ..."
	@$(CCX) $(CFLAGS) -MM *.c > $@



include .depend

=== distro/fedora/Makefile ===
SPEC         = hime-fedora.spec
VERSION_FILE = ../../VERSION.hime


all: $(SPEC)

hime-fedora.spec: hime-fedora.spec.in $(VERSION_FILE)
	@echo "building $@ ..."
	@rm -f $@
	@sed -e "s/__hime_version__/`cat $(VERSION_FILE)`/" < $< > $@

clean:
	@rm -f $(SPEC)

=== src/IMdkit/Makefile ===
include ../../config.mak

all: libXimd.a

libXimd.a:
	$(MAKE) -C lib

clean:
	rm -f *.bak *~
	$(MAKE) -C lib clean

install:
	@echo nothing to be installed.

=== src/gtk-im/Makefile ===
include ../../config.mak

OBJS = imhime.o gtkimcontexthime.o
GTK2IM=gtk-2.0/immodules
GTKINC=`pkg-config --cflags gtk+-2.0`
LDFLAGS=`pkg-config --libs gtk+-2.0`
IMMODULES=$(libdir)/$(GTK2IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK2IM)


ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	@echo "  $< -> $@"
	@$(CC) -c -fPIC $(CFLAGS) -o $@ $<

.c.E:
	@echo "  $< -> $@"
	@$(CC) -E $(CFLAGS) -o $@ $<

all:	im-hime.so

im-hime.so:     $(OBJS) ../im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lhime-im-client -o $@ $(LDFLAGS)
	@rm -f core.*

clean:
	@echo "clean up"
	@rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(IMMODULES_LOCAL); \
		install -m 755 im-hime.so $(IMMODULES_LOCAL); \
		cd /etc/gtk-2.0; gtk-query-immodules-2.0 > gtk.immodules; \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-hime.so $(IMMODULES); \
	fi

.depend:
	@echo "building $@ ..."
	@$(CC) $(CFLAGS) -MM *.c > $@

include .depend

=== src/gtk3-im/Makefile ===
include ../../config.mak

OBJS = imhime.o gtkimcontexthime.o
GTK3IM=gtk-3.0/immodules
GTKINC=`pkg-config --cflags gtk+-3.0`
LDFLAGS=`pkg-config --libs gtk+-3.0`
IMMODULES=$(libdir)/$(GTK3IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK3IM)


ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	@echo "  $< -> $@"
	@$(CC) -c -fPIC $(CFLAGS) -o $@ $<

.c.E:
	@echo "  $< -> $@"
	@$(CC) -E $(CFLAGS) -o $@ $<

all:	im-hime.so

im-hime.so:     $(OBJS) ../im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lhime-im-client -o $@ $(LDFLAGS)
	@rm -f core.*

clean:
	@echo "clean up"
	@rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(IMMODULES_LOCAL); \
		install -m 755 im-hime.so $(IMMODULES_LOCAL); \
		gtk-query-immodules-3.0 --update-cache; \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-hime.so $(IMMODULES); \
	fi

.depend:
	@echo "building $@ ..."
	@$(CC) $(CFLAGS) -MM *.c > $@

include .depend

=== src/im-client/Makefile ===
include ../../config.mak

SOFILE=libhime-im-client.so
SOFILEVER=libhime-im-client.so.1.2.4

.SUFFIXES:      .c .o .E .cpp
WALL=-Wall
CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) -I. -I.. -I../IMdkit/include $(GTKINC) \
        -DCLIENT_LIB=1 -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" -DUNIX=1 \
        -DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
        -DFREEBSD=$(FREEBSD) -fPIC
OBJS = hime-im-client.o hime-send.o im-addr.o hime-conf.o util.o hime-crypt-fpic.o

.cpp.E:
	@echo "  $< -> $@"
	@$(CC) $(CFLAGS) -E -o $@ $<

.c.o:
	@echo "  $< -> $@"
	@$(CC) -c $(CFLAGS) $<

.cpp.o:
	@echo "  $< -> $@"
	@$(CC) -x c -c $(CFLAGS) $<

$(SOFILEVER):   $(OBJS)
	@echo "linking $@ ..."
	@$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -o $@ -L/usr/X11R6/lib
	ln -sf $(SOFILEVER) $(SOFILE)
	ln -sf $(SOFILEVER) $(SOFILE).1
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C ../gtk-im; fi

LOCALLIB=/usr/local/$(LIB)

install:
	install -d $(himelibdir)
	install -m 755 $(SOFILEVER) $(himelibdir)
	cd $(himelibdir); rm -f $(SOFILE); ln -s $(SOFILEVER) $(SOFILE); \
	ln -sf $(SOFILEVER) $(SOFILE).1

hime-conf.o: ../hime-conf.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CFLAGS) -o $@ $<

util.o: ../util.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CFLAGS) -o $@ $<

im-addr.o: ../im-addr.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CFLAGS) -o $@ $<

hime-crypt-fpic.o: ../hime-crypt.c
	@echo "  $^ -> $@"
	@$(CCX) -c $(CFLAGS) -o $@ $<

clean:
	@echo "clean up"
	@rm -f *.o *.so *.so.* *~ *.E *.db tags core.* .depend

.depend:
	@echo "building $@ ..."
	@$(CCX) $(CFLAGS) -MM *.c > $@

include .depend

=== debian/changelog ===
hime (0.9.9-1) unstable; urgency=low

  * Initial release (Closes: #652022)

 -- Yao Wei (魏銘廷) <mwei@lxde.org>  Sat, 14 Jan 2012 00:24:08 +0800

=== debian/control ===
Source: hime
Section: utils
Priority: optional
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>
Standards-Version: 3.9.2
Homepage: http://hime.luna.com.tw
Build-Depends: debhelper (>= 8.0.0), libgtk2.0-dev (>= 2.20.0), libgtk-3-dev,
 libqt4-dev, libchewing3-dev, libxtst-dev, libanthy-dev, autotools-dev
Vcs-Git: git://git.debian.org/pkg-ime/hime.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/hime.git;a=summary

Package: hime
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime-data, hime-tables
Recommends: im-config | im-switch, hime-gtk3-immodule
Suggests: hime-anthy, hime-chewing, hime-qt4-immodule
Description: GTK+ based input method for Chinese users
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains only GTK2 immodule. For GTK3 and Qt4 immodule, 
 please install correspondence packages.

Package: hime-data
Architecture: all
Depends: ${misc:Depends}
Description: icons, locales and scripts for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains icons, locales, scripts and other architecture-
 independent things.

Package: hime-tables
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: input method tables for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains architecture-dependent input method tables.

Package: hime-dev
Section: devel
Architecture: all
Depends: ${misc:Depends}, hime (>= ${source:Version})
Description: development files for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package provides header files of HIME.

Package: hime-qt4-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version})
Description: Qt4 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the Qt4 input method module (immodule) for HIME.

Package: hime-gtk3-immodule
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version})
Description: GTK3 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the GTK3 input method module (immodule) for HIME.

Package: hime-anthy
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version}), anthy
Description: support library to use Anthy in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use anthy in HIME.

Package: hime-chewing
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, hime (>= ${source:Version})
Description: support library to use Chewing in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use chewing in HIME.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

GTK2VER = $(shell pkg-config --variable=gtk_binary_version gtk+-2.0)
GTK3VER = $(shell pkg-config --variable=gtk_binary_version gtk+-3.0)

%:
	dh $@ 

override_dh_auto_clean:
	make clean
	rm config.mak
 
override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# move libraries to the correspond gtk version
	mkdir -p debian/tmp/usr/lib/gtk-2.0/$(GTK2VER)
	mv debian/tmp/usr/lib/gtk-2.0/immodules debian/tmp/usr/lib/gtk-2.0/$(GTK2VER)/
	mkdir -p debian/tmp/usr/lib/gtk-3.0/$(GTK3VER)
	mv debian/tmp/usr/lib/gtk-3.0/immodules debian/tmp/usr/lib/gtk-3.0/$(GTK3VER)/

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/hime/table debian/tmp/usr/lib/hime/
	ln -s /usr/lib/hime/table debian/tmp/usr/share/hime/table

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_makeshlibs:
	dh_makeshlibs -n

## hime 0.9.9%2Bgit20120619%2Bdfsg

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,11 @@
 include config.mak
 
-VERSION_FILE = VERSION.hime
+VERSION_FILE = ChangeLog
 
 DIR    = src data filter scripts icons man menu
 
 ifeq ($(ECHO),)
-ECHO  := $(shell whereis -b echo|sed 's/^echo: *\([^ ]\+\).*/\1/')
+ECHO  := $(shell whereis -b echo | awk '{print $$2}')
 ifeq ($(ECHO),)
 ECHO   = echo
 endif
@@ -18,15 +18,14 @@
 
 all:
 	@for d in $(DIR); do $(ECHO) -e "\x1b[1;33m** processing $$d\x1b[0m"; \
-	   $(MAKE) -C $$d; \
+	   $(MAKE) -C $$d || exit 1; \
 	done
 
 install:
 	@for d in $(DIR); do $(ECHO) -e "\x1b[1;32m** installing $$d\x1b[0m"; \
-	   $(MAKE) -C $$d install; \
+	   $(MAKE) -C $$d install || exit 1; \
 	done
 	@if [ $(prefix) = /usr/local ]; then \
-	   install -m 644 icons/hime.png /usr/share/pixmaps; \
 	   install -d $(DOC_DIR); \
 	   install -m 644 ChangeLog $(DOC_DIR); \
 	else \

=== src/qt-im/Makefile ===
include ../../config.mak
QT=qt3
QTIM=$(QT)/plugins/inputmethods
IMMODULES=$(libdir)/$(QTIM)
INCS=-I../im-client -I/usr/include `pkg-config --cflags qt-mt` -I/usr/include/Xft2/X11/Xft  -I/usr/include/fontconfig -I/usr/include/freetype2
CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT_THREAD_SUPPORT -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG
OBJS=qhimeinputcontextplugin.o qhimeinputcontextplugin_my.o qhimeinputcontext.o qhimeinputcontext_x11.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS=-L../im-client -lhime-im-client -Wl,-rpath,$(himelibdir) `pkg-config qt-mt --libs`
all:	im-hime.so

.cpp.E:
	@echo "  $< -> $@"
	@$(CXX) -E $(CFLAGS) $(INCS) $< > $@

.cpp.o:
	@echo "  $< -> $@"
	@$(CXX) -c -o $@ $(CXXFLAGS) $<

.h.o:
	@echo "  $< -> $@"
	@$(QT3_MOC_PATH) $< -o $<_moc.cpp
	@$(CXX) -c -pipe $(CXXFLAGS) $<_moc.cpp -o $@

im-hime.so: $(OBJS)
	@echo "linking $@ ..."
	@$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	@rm -f core.*

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(DESTDIR)/$(QT_IM_DIR); \
		install -m 755 im-hime.so $(DESTDIR)/$(QT_IM_DIR); \
	else \
		install -d $(IMMODULES); \
                install -m 755 im-hime.so $(IMMODULES); \
	fi

clean:
	@echo "clean up"
	@rm -f $(OBJS) im-hime.so *~ core.* *moc*.cpp *.E

## hime 0.9.9+git20120619+dfsg

=== data/Makefile ===
--- 
+++ 
@@ -5,7 +5,6 @@
 
 .SUFFIXES:	.kbmsrc .kbm .cin .gtab
 CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I$(SRC_DIR)
-export NO_GTK_INIT=
 export HIME_NO_RELOAD=
 
 DATA=pho.tab2 tsin32.idx gtab.list \

=== filter/Makefile ===
include ../config.mak

all:

install:
	install -d $(filterdir)
	install -m 755 [a-z]* $(filterdir)

clean:
	@echo "clean up"
	@rm -f *~

=== icons/Makefile ===
--- 
+++ 
@@ -16,8 +16,7 @@
 	install -m 644 hime.png $(datadir)/pixmaps
 	install -d $(HIME_ICON_DIR_i)
 	install -m 644 30x30/*.png $(HIME_ICON_DIR_i)
-	@for d in $(DIR); do \
-	   set -x ; \
+	@set -x ; for d in $(DIR); do \
 	   $(ECHO) -e "\x1b[1;32m** installing icons/$$d\x1b[0m"; \
 	   install -d $(HIME_ICON_DIR_i)/$$d ; \
 	   install -m 644 $$d/*.png $(HIME_ICON_DIR_i)/$$d ; \

=== man/Makefile ===
include ../config.mak

all:

install:
	install -d $(man1dir)
	install -m 644 *.1 $(man1dir)

clean:
	@echo "clean up"
	@rm -f *~

=== menu/Makefile ===
include ../config.mak

all:

install:
	if [ $(prefix) = /usr/local ]; then \
	   install hime-setup.desktop /usr/share/applications; \
	   which update-menus > /dev/null 2>&1 && update-menus || exit 0; \
	else \
	   install -d $(datadir)/applications; \
	   install -m 644 hime-setup.desktop $(datadir)/applications; \
	fi

clean:
	@echo "clean up"
	@rm -f $(MENUS) *~

=== po/Makefile ===
include ../config.mak

LANG_FILE = $(shell ls -d *.po | sed 's/\.po//g')

ifeq ($(ECHO),)
ECHO  := $(shell whereis -b echo | awk '{print $$2}')
ifeq ($(ECHO),)
ECHO   = echo
endif
endif

all: gmo

gmo:
	@set -x ; for d in $(LANG_FILE); do \
	   $(ECHO) -e "\x1b[1;32m** generating $$d.gmo\x1b[0m"; \
	   rm -f $$d.gmo ; \
	   msgfmt -v -o $$d.gmo $$d.po ; \
	done

hime.pot:
	xgettext --from-code=UTF-8 --keyword=_ --keyword=N_ -o $@ ../*/*.c ../src/*/*.c*

update-po: hime.pot
	@set -x ; for d in $(LANG_FILE); do \
	   $(ECHO) -e "\x1b[1;32m** updating $$d.po\x1b[0m"; \
	   msgmerge -v $$d.po hime.pot > $$d.new.po ; \
	   mv $$d.new.po $$d.po ; \
	done

install:
	@set -x ; for d in $(LANG_FILE); do \
	   $(ECHO) -e "\x1b[1;32m** installing $$d.mo\x1b[0m"; \
	   install -d $(datadir)/locale/$$d/LC_MESSAGES ; \
	   install -m 644 $$d.gmo $(datadir)/locale/$$d/LC_MESSAGES/hime.mo ; \
	done

clean:
	rm -f ./hime.pot *.gmo *.new.po

=== scripts/Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 include ../config.mak
 
-SCRIPTS=hime-user-setup utf8-edit gtab.append_prepare tsin-gtab-import tsin-gtab-edit
+SCRIPTS=hime-user-setup utf8-edit gtab.append_prepare tsin-gtab-import
 BIN_SCRIPTS=hime-env
 
 all:	$(SCRIPTS)

=== src/Makefile ===
--- 
+++ 
@@ -8,11 +8,10 @@
         -DHIME_ICON_DIR=\"$(HIME_ICON_DIR)\" \
         -DHIME_SCRIPT_DIR=\"$(HIME_SCRIPT_DIR)\" -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" \
         -DSYS_ICON_DIR=\"$(SYS_ICON_DIR)\" -DFREEBSD=$(FREEBSD) -DMAC_OS=$(MAC_OS) \
+        -DHIME_VERSION=\"$(shell head -n 1 ../ChangeLog)\" \
         -DG_DISABLE_SINGLE_INCLUDES -DG_DISABLE_DEPRECATED \
         -DGDK_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
         -DGTK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED -DGSEAL_ENABLE
-
-VERSION_FILE = ../VERSION.hime
 
 OBJ_IMSRV = im-addr.o im-dispatch.o im-srv.o hime-crypt.o
 
@@ -72,7 +71,7 @@
 OBJS_gtab_merge   = hime-gtab-merge.o gtab-util.o util.o locale.o
 OBJS_hime_setup   = hime-setup.o hime-conf.o util.o hime-settings.o \
 	hime-setup-list.o locale.o hime-setup-pho.o about.o \
-	lang.o hime-icon.o hime-setup-gtab.o gtab-list.o hime-exec-script.o \
+	lang.o hime-icon.o hime-setup-gtab.o hime-setup-appearance.o gtab-list.o hime-exec-script.o \
 	pho-kbm-name.o hime-module-cb.o
 
 OBJS_hime_gb_toggle  = hime-gb-toggle.o  hime-conf.o util.o
@@ -94,7 +93,10 @@
 
 ifeq ($(USE_TRAY),Y)
 CFLAGS     += -DTRAY_ENABLED=1
-OBJS       += tray.o eggtrayicon.o tray-double.o
+OBJS       += tray.o tray-double.o
+ifeq ($(GTK),gtk+-2.0)
+OBJS       += gdkpixbuf-drawable.o
+endif
 ifeq ($(USE_UNITY),Y)
 CFLAGS     += -DTRAY_UNITY=1
 OBJS       += tray-appindicator.o
@@ -158,7 +160,7 @@
 	@$(CCX) $(CFLAGS) -E -o $@ $<
 
 
-all: hime-version.h $(PROGS) $(PROGS_SYM) $(DATA) $(PROGS_CV)
+all: $(PROGS) $(PROGS_SYM) $(DATA) $(PROGS_CV)
 	if [ $(BUILD_MODULE) = 'Y' ]; then $(MAKE) -C modules; fi
 	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im; fi
 	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
@@ -183,7 +185,11 @@
 
 hime: $(HIME_SO) $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
 	@echo "linking $@ ..."
+ifeq ($(FREEBSD), 0)
 	@$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) $(HIME_SO) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
+else
+	@$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) $(HIME_SO) -lXtst $(LDFLAGS) -L/usr/local/$(LIB)
+endif
 	@rm -f core.* vgcore.*
 
 hime-tslearn: $(OBJS_TSLEARN) im-client/libhime-im-client.so
@@ -276,11 +282,6 @@
 hime-tsin2gtab-phrase: $(OBJS_tsin2gtab_phrase)
 	@echo "linking $@ ..."
 	@$(CCLD) -o $@ $^ $(LDFLAGS)
-
-
-hime-version.h: $(VERSION_FILE)
-	@echo "building $@ ... current version is '"`cat $<`"'"
-	@echo '#define HIME_VERSION "'`cat $<`'"' > $@
 
 install:
 	install -d $(bindir)

=== src/gtk-im/Makefile ===
--- 
+++ 
@@ -4,8 +4,12 @@
 GTK2IM=gtk-2.0/immodules
 GTKINC=`pkg-config --cflags gtk+-2.0`
 LDFLAGS=`pkg-config --libs gtk+-2.0`
+GTK_LIBDIR=`pkg-config --variable=libdir gtk+-2.0`
+GTK_BINARY_VERSION=`pkg-config --variable=gtk_binary_version gtk+-2.0`
+MODULEDIR=$(DESTDIR)/$(GTK_LIBDIR)/gtk-2.0/$(GTK_BINARY_VERSION)/immodules
 IMMODULES=$(libdir)/$(GTK2IM)
 IMMODULES_LOCAL=/usr/$(LIB)/$(GTK2IM)
+IMMODULES_QUERY=`whereis gtk-query-immodules-2.0 | cut -d ' ' -f 2`
 
 
 ifeq ($(MAC_OS),1)
@@ -36,10 +40,14 @@
 	@rm -f *.o *.so *~ core.* .depend *.E
 
 install:
-	if [ $(prefix) = /usr/local ]; then \
-		install -d $(IMMODULES_LOCAL); \
-		install -m 755 im-hime.so $(IMMODULES_LOCAL); \
-		cd /etc/gtk-2.0; gtk-query-immodules-2.0 > gtk.immodules; \
+	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
+		install -d $(MODULEDIR); \
+		install -m 755 im-hime.so $(MODULEDIR); \
+		if [ "$(prefix)" = "/usr/local" ]; then \
+			if [ -d $(DESTDIR)/etc/gtk-2.0 ]; then \
+				cd $(DESTDIR)/etc/gtk-2.0; $(IMMODULES_QUERY) > gtk.immodules; \
+			fi \
+		fi \
 	else \
 		install -d $(IMMODULES); \
 		install -m 755 im-hime.so $(IMMODULES); \

=== src/gtk3-im/Makefile ===
--- 
+++ 
@@ -4,9 +4,13 @@
 GTK3IM=gtk-3.0/immodules
 GTKINC=`pkg-config --cflags gtk+-3.0`
 LDFLAGS=`pkg-config --libs gtk+-3.0`
+GTK3_LIBDIR=`pkg-config --variable=libdir gtk+-3.0`
+GTK3_BINARY_VERSION=`pkg-config --variable=gtk_binary_version gtk+-3.0`
+MODULEDIR=$(DESTDIR)/$(GTK3_LIBDIR)/gtk-3.0/$(GTK3_BINARY_VERSION)/immodules
 IMMODULES=$(libdir)/$(GTK3IM)
 IMMODULES_LOCAL=/usr/$(LIB)/$(GTK3IM)
-
+IMMODULES_QUERY=$(shell `whereis gtk-query-immodules-3.0 | awk -F ' = ' '{print $2}'`)
+IMMODULES_CACHE=$(DESTDIR)/$(GTK3_LIBDIR)/gtk-3.0/$(GTK3_BINARY_VERSION)/immodules.cache
 
 ifeq ($(MAC_OS),1)
 EXTRA_INC=-I/sw/include
@@ -36,10 +40,14 @@
 	@rm -f *.o *.so *~ core.* .depend *.E
 
 install:
-	if [ $(prefix) = /usr/local ]; then \
-		install -d $(IMMODULES_LOCAL); \
-		install -m 755 im-hime.so $(IMMODULES_LOCAL); \
-		gtk-query-immodules-3.0 --update-cache; \
+	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
+		install -d $(MODULEDIR); \
+		install -m 755 im-hime.so $(MODULEDIR); \
+		if [ "$(prefix)" = "/usr/local" ]; then \
+			if [ -f "$(IMMODULES_QUERY)" -a -x "$(IMMODULES_QUERY)" ]; then \
+				GTK_IM_MODULE_FILE=$(IMMODULES_CACHE) $(IMMODULES_QUERY) --update-cache; \
+			fi \
+		fi \
 	else \
 		install -d $(IMMODULES); \
 		install -m 755 im-hime.so $(IMMODULES); \

=== src/im-client/Makefile ===
--- 
+++ 
@@ -25,7 +25,12 @@
 
 $(SOFILEVER):   $(OBJS)
 	@echo "linking $@ ..."
-	@$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -o $@ -L/usr/X11R6/lib
+# TODO: Drop g_get_tmp_dir() and -lglib-2.0
+ifeq ($(FREEBSD), 0)
+	@$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/X11R6/lib
+else
+	@$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/local/lib
+endif
 	ln -sf $(SOFILEVER) $(SOFILE)
 	ln -sf $(SOFILEVER) $(SOFILE).1
 	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C ../gtk-im; fi

=== src/modules/Makefile ===
include ../../config.mak
include ../suffixes-rule

CFLAGS+=-I.. -I../IMdkit/include
HIME_MODULE=intcode-module.so

ifeq ($(USE_ANTHY),Y)
HIME_MODULE+=anthy-module.so
endif

ifeq ($(USE_CHEWING),Y)
HIME_MODULE+=chewing-module.so
CHEWING_DATADIR=$(shell pkg-config --variable=datadir chewing)
CFLAGS += -DCHEWING_DATADIR=\"$(CHEWING_DATADIR)\" $(shell pkg-config --cflags chewing)
endif

all:	$(HIME_MODULE)

anthy_module_so = anthy.pico
anthy-module.so: $(anthy_module_so)
	@echo "linking $@ ..."
	@$(CCLD) $(SO_FLAGS) -o $@ $(anthy_module_so) $(LDFLAGS) -lanthy

intcode_module_so = intcode.pico win-int.pico
intcode-module.so: $(intcode_module_so)
	@echo "linking $@ ..."
	@$(CCLD) $(SO_FLAGS) -o $@ $(intcode_module_so) $(LDFLAGS)

chewing_module_obj = chewing-conf.pico
chewing_module_so = chewing.pico hime-setup-chewing.pico
chewing-module.so: $(chewing_module_obj) $(chewing_module_so)
	@echo "linking $@ ..."
	@$(CCLD) $(SO_FLAGS) -o $@ $(chewing_module_obj) $(chewing_module_so) $(LDFLAGS) $(shell pkg-config --cflags --libs chewing)

install:
	install $(HIME_MODULE) $(himelibdir)

clean:
	@echo "clean up"
	@rm -f *.pico *.so *.o

=== debian/changelog ===
hime (0.9.9+git20120619+dfsg-1) unstable; urgency=low

  * Imported Upstream version 0.9.9+git20120609+dfsg
  * debian/control:
    - upgrade dh compatibility to 9
    - add dependency to dpkg-dev
  * debian/compat: upgrade dh compatibility to 9
  add copyright information for DFSG git package
  * debian/rules:
    - dirty hack for autoclean
    - remove moving gtk immodules to specific directories
    - add hardening flags
  * debian/hime.install, debian/hime-gtk3-immodule.install:
    update gtk immodules install path
  * debian/copyright: add copyright information for DFSG git package

 -- Yao Wei (魏銘廷) <mwei@lxde.org>  Sat, 09 Jun 2012 11:42:18 +0800

hime (0.9.9-2) unstable; urgency=low

  * im-switch configuration fix
  * copyright year update
  * upgrade debian policy standard version to 3.9.3
  * fix im-switch hook script (Closes: #664657)
  * set DM-Upload-Allowed to yes

 -- Yao Wei (魏銘廷) <mwei@lxde.org>  Tue, 03 Apr 2012 15:48:37 +0800

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,14 @@
 Priority: optional
 Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
 Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://hime.luna.com.tw
-Build-Depends: debhelper (>= 8.0.0), libgtk2.0-dev (>= 2.20.0), libgtk-3-dev,
- libqt4-dev, libchewing3-dev, libxtst-dev, libanthy-dev, autotools-dev
+Build-Depends: debhelper (>= 9.0.0), libgtk2.0-dev (>= 2.20.0), libgtk-3-dev,
+ libqt4-dev, libchewing3-dev, libxtst-dev, libanthy-dev, autotools-dev,
+ dpkg-dev (>= 1.16.1~)
 Vcs-Git: git://git.debian.org/pkg-ime/hime.git
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-ime/hime.git;a=summary
+DM-Upload-Allowed: yes
 
 Package: hime
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)

%:
	dh $@ 

override_dh_auto_clean:
	touch config.mak # dirty hack to make Makefile thinks config.mak exists
	make clean
	rm config.mak
 
override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/hime/table debian/tmp/usr/lib/hime/
	ln -s /usr/lib/hime/table debian/tmp/usr/share/hime/table

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_makeshlibs:
	dh_makeshlibs -n

=== debian/watch ===
version=3
https://github.com/caleb-/hime/downloads /downloads/caleb-/hime/hime-(.*).dfsg.orig.tar.xz
